Index: uspace/drv/uhci-hcd/iface.c
===================================================================
--- uspace/drv/uhci-hcd/iface.c	(revision 7dd3318d27ef639ceb71f338262b6270c0fd4459)
+++ uspace/drv/uhci-hcd/iface.c	(revision 83c439ccd5bc176ae6ed6a165dcba2d795f3826d)
@@ -109,9 +109,9 @@
 	dev_speed_t speed = FULL_SPEED;
 
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_INTERRUPT,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_INTERRUPT,
 	    max_packet_size, speed, data, size, NULL, 0, NULL, callback, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_interrupt_out(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_interrupt_out(batch);
 	return EOK;
 }
@@ -124,9 +124,9 @@
 	dev_speed_t speed = FULL_SPEED;
 
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_INTERRUPT,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_INTERRUPT,
 	    max_packet_size, speed, data, size, NULL, 0, callback, NULL, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_interrupt_in(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_interrupt_in(batch);
 	return EOK;
 }
@@ -139,10 +139,10 @@
 	dev_speed_t speed = FULL_SPEED;
 
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, data, size, setup_data, setup_size,
 	    NULL, callback, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_write(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_write(batch);
 	return EOK;
 }
@@ -155,10 +155,10 @@
 	dev_speed_t speed = FULL_SPEED;
 
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, data, size, setup_data, setup_size, callback,
 	    NULL, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_read(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_read(batch);
 	return EOK;
 }
@@ -172,9 +172,9 @@
 
 	usb_log_warning("Using deprecated API %s.\n", __FUNCTION__);
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, NULL, 0, data, size, NULL, callback, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_setup_old(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_setup_old(batch);
 	return EOK;
 }
@@ -188,9 +188,9 @@
 
 	usb_log_warning("Using deprecated API %s.\n", __FUNCTION__);
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, data, size, NULL, 0, NULL, callback, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_write_data_old(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_write_data_old(batch);
 	return EOK;
 }
@@ -203,9 +203,9 @@
 
 	usb_log_warning("Using deprecated API %s.\n", __FUNCTION__);
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, NULL, 0, NULL, 0, callback, NULL, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_write_status_old(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_write_status_old(batch);
 	return EOK;
 }
@@ -219,9 +219,9 @@
 
 	usb_log_warning("Using deprecated API %s.\n", __FUNCTION__);
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, NULL, 0, data, size, NULL, callback, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_setup_old(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_setup_old(batch);
 	return EOK;
 }
@@ -235,9 +235,9 @@
 
 	usb_log_warning("Using deprecated API %s.\n", __FUNCTION__);
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, data, size, NULL, 0, callback, NULL, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_read_data_old(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_read_data_old(batch);
 	return EOK;
 }
@@ -250,9 +250,9 @@
 
 	usb_log_warning("Using deprecated API %s.\n", __FUNCTION__);
-	tracker_t *tracker = tracker_get(dev, target, USB_TRANSFER_CONTROL,
+	batch_t *batch = batch_get(dev, target, USB_TRANSFER_CONTROL,
 	    max_packet_size, speed, NULL, 0, NULL, 0, NULL, callback, arg);
-	if (!tracker)
-		return ENOMEM;
-	tracker_control_read_status_old(tracker);
+	if (!batch)
+		return ENOMEM;
+	batch_control_read_status_old(batch);
 	return EOK;
 }